/**********************************************/
/*                                            */    
/* iFilesOperations.h                         */
/*                                            */
/* files operations (copy, move)              */
/*                                            */
/* scol v 4                                   */
/*                                            */
/**********************************************/






//with reboot if necessary
#define IFOP_MODE_UNSAFE 0x00000001

//no reboot, but a check on files version (filenames)
#define IFOP_MODE_SAFE   0x00000002






/**********************************************************/
/*                                                        */
/* DWORD ifopCopyF (LPCTSTR src, LPCTSTR dst, DWORD mode) */
/*                                                        */
/* scol v 4 : replace old function CopyF                  */
/*                                                        */
/* Copy a file.                                           */
/*                                                        */
/*                                                        */
/*                                                        */
/* parameter mode :                                       */
/*                                                        */
/*    - IFOP_MODE_UNSAFE (<=> NULL) : then function will  */
/* try to copy the file after reboot if a direct copy     */
/* goes wrong.                                            */
/*                                                        */
/*    - IFOP_MODE_SAFE : the function won't try to copy   */
/* file after reboot. It will check the file version      */
/* (stored in its name), and won't do anything if names   */
/* are the same.                                          */
/*                                                        */
/*                                                        */
/*                                                        */
/* return 0 if success. -1 means error on parameters      */
/* (filenames NULL...)                                    */
/*                                                        */
/* if error (file locked), call an internal function to   */
/* make the copy after the reboot.                        */
/*                                                        */
/* this method (copy a file when it's locked) is          */
/* different depending on the operating system version.   */
/* ifopCopyF manages all windows version :) yeah :)       */
/*                                                        */
/**********************************************************/
DWORD ifopCopyF (LPCTSTR src, LPCTSTR dst, DWORD mode);




