/**********************************************/
/*                                            */    
/* inetscape.h                                */
/*                                            */
/* netscape management                        */
/*   - scol plugin for netscape               */
/*   - scol protocol                          */
/*                                            */
/* scol v 4                                   */
/*                                            */
/* by Loc Berthelot, CryoNetworks, may 2001  */
/*                                            */
/**********************************************/

#ifndef _INETSCAPE_H
#define _INETSCAPE_H




extern char** netscapePathsTab;
extern int    netscapePathsTabLength;

extern char** netscape6PathsTab;
extern int    netscape6PathsTabLength;



void netscapeInitData ();




/**************************************************************/
/*                                                            */
/* DWORD FindNetscape (LPCTSTR keyName,                       */
/*                     LPCTSTR exeDirectory                   */
/*                     LPCTSTR exeName,                       */
/*                     char*** tab, int* tabLength)            */
/*                                                            */
/* find netscape navigator in registry                        */
/* with the key, given in parameter                           */
/* if netscape are found, paths are                           */
/* stored in netscapePathsTab                                 */
/*                                                            */
/* parameters :                                               */
/*                                                            */
/*   char* keyName : netscape root key name in registry       */
/*                   (netscape 6 different from netscape < 6) */
/*                                                            */
/*   char* exeDirectory : directory to get the executable file*/
/*                                                            */
/*   char* exeName : netscape executable file name            */
/*                                                            */
/**************************************************************/
DWORD FindNetscape(LPCTSTR keyName, LPCTSTR exeDirectory, LPCTSTR exeName, char*** tab, int* tabLength);




/****************************************/
/*                                      */
/* DWORD IsNetscapeDefault()            */
/*                                      */
/* check if Netscape is the default     */
/* web browser. Set the NETSCAPEDEFAULT */
/* environnement variable (value "YES"  */
/* or "NO"), and return 1 or 0.         */
/****************************************/
DWORD IsNetscapeDefault();




/*****************************************************/
/*                                                   */
/* DWORD EnumNetscapePaths (LPTSTR netscapePathVar)  */
/*                                                   */
/* pull a netscape path from the netscape path       */
/* tab, and store it into the environnement var      */
/* given as parameter.                               */
/* Return 1 if a netscape path has been pulled,      */
/* 0 if no more data in netscape path tab.           */
/*                                                   */
/*****************************************************/
DWORD EnumNetscapePaths (LPTSTR netscapePathVar);




/*****************************************************/
/*                                                   */
/* DWORD EnumNetscape6Paths (LPTSTR netscapePathVar) */
/*                                                   */
/* pull a netscape6 path from the netscape6 path     */
/* tab, and store it into the environnement var      */
/* given as parameter.                               */
/* Return 1 if a netscape6 path has been pulled,     */
/* 0 if no more data in netscape6 path tab.          */
/*                                                   */
/*****************************************************/
DWORD EnumNetscape6Paths (LPTSTR netscapePathVar);


#endif